;===============================================================================
; fs1000a_inc.inc - fs1000a library file. Need fs1000a_lib.asm & fs1000a_extern.inc to use
;===============================================================================
;  1 -      
;      P3.2 (INT0),  P3.3 (INT1)

;  !!!     100   .      1   100 
;   200      .      350-1000 
;   50-100      ,  ,  , 
;        -      2    
;  '    ,       
;    :      ,  - 
;      ,   - 
;      40-50    ,        100
;    ,    .        3-4,
;     15-20  ,  ,    
;      㳿 2  ,       

; :
;  ,    (   MCS-51)      (     '   Timer0)
;  '           ( 12   ,  11,0592   ,  )
; '    .       .        (0  1),
;         ,         ,     
;      ,      

; :
;        12,      ,    '   Timer0.   - ,   24,        2 .           
; 0      100h  1FFh  Timer0.  12    256us  511us (   - 384us)
; 1      200h  2FFh  Timer0.  12    512us  767us (   - 640us)
;        300h  3FFh  Timer0.  12    768us  1023us (   - 900us)
;  -   ( , ,   )    ,   100h  1FFh  Timer0.  12    256us  511us (   - 384us)
;        -  
;      - 
;       ( )     -  
; -        -   (        300h  3FFh  Timer0)

;  :
;   :
;  2 : INT0 ( INT1),    Timer0.     Timer0 -   ( Timer0,      ).          
;  Timer0     (TL0 = 0, TH0 = 0FCh),    8  ,    
;      -  Timer0,    INT0 (INT1),       

;   :
;       -    INT0 (INT1)
;  TL0  0.    255    TH0.         

;     .   -   .   -   

;   
;   TH0.  TH0! = 0FFh -  
;  -     -     
;         

;   
;   TH0.  TH0 = 0FEh -  .0,  TH0 = 0FFh -  .1 (    :  0FEh   TH0. .1   , .0   .      .      ,    Timer0)
;       ( ),    .   0 -     8  

;     .  0,   1-   -  ,     ,  checksum (  ,     )

;    
; ĳ     ,     checksum,        ,   ,    
;         

;    ,  checksum
; ĳ     
;    .   0 -  .     checksum,  ,    .   
;    0,    (xrl)     checksum,     ,    
;         

;       
;  Timer0      (TH0 = 0FEh),  TL0   ,   ,     
;        Timer0:
; jb	TF0,	Receive_Error
; jnb	xy_mk_5v_pin,$-3
;     TH0.  TH0! = 0FFh,  
;   ,  Timer0     (TL0 = 0, TH0 = 0FDh)

;  :
; 1. 1   
; 2. 16-20   
; 3. 1 
; 4.   - LEN (LEN> = 2 && LEN <= BUFF_SIZE+1) DATA + CHECKSUM
; 5.   - DATA
; 6.   - CHECKSUM (LEN + XOR all DATA bytes)
;===============================================================================
FS1000A_TRANSMIT_PIN		bit	P3.5

USE_TRANSMIT_COMPL_PIN		equ	1

if	USE_TRANSMIT_COMPL_PIN

FS1000A_TRANSMIT_COMPL_PIN	bit	P3.7											; indication of the end of the transmission procedure: 1 - transmit in process, 0 - transmit complete

RESTORE_TRANSMIT_COMPL_PIN	equ	0												; 1 - only 1 short pulse on FS1000A_TRANSMIT_COMPL_PIN, 0 - FS1000A_TRANSMIT_COMPL_PIN keeps low level

	if	RESTORE_TRANSMIT_COMPL_PIN = 0
		LOW_TRANSMIT_COMPL_PIN_AT_START    equ 0
	endif

endif

if	LOW_TRANSMIT_COMPL_PIN_AT_START
_fs1000a_init	macro															; use for first clear FS1000A_TRANSMIT_COMPL_PIN
				clr		FS1000A_TRANSMIT_COMPL_PIN
				endm
endif
;===============================================================================
FS1000A_BUFFSIZE	equ	48														; Max BUFFSIZE for AT89C1051 = 48. Stack = 11 bytes
SHORT_IMPULSE_NUM	equ	16
FS1000A_BITNUM		equ	8
;===============================================================================
fs1000a_delay		equ	R1
fs1000a_bitcount	equ	R2
fs1000a_bytecount	equ	R3
fs1000a_checksum	equ	4h														; direct addr for command: xrl fs1000a_checksum,A
;===============================================================================
_fs1000a_send_pack	macro	ptr,	size
					mov		R0,		#ptr
					mov		A,		size
					call	FS1000A_send_pack
					endm
;===============================================================================
