;===============================================================================
; xy_mk_5v_inc.inc - xy_mk_5v include file. Need xy_mk_5v_lib.asm & xy_mk_5v_extern.inc to use
;===============================================================================
;  1 -      
;      P3.2 (INT0),  P3.3 (INT1)

;  !!!     100   .      1   100 
;   200      .      350-1000 
;   50-100      ,  ,  , 
;        -      2    
;  '    ,       
;    :      ,  - 
;      ,   - 
;      40-50    ,        100
;    ,    .        3-4,
;     15-20  ,  ,    
;      㳿 2  ,       

; :
;  ,    (   MCS-51)      (     '   Timer0)
;  '           ( 12   ,  11,0592   ,  )
; '    .       .        (0  1),
;         ,         ,     
;      ,      

; :
;        12,      ,    '   Timer0.   - ,   24,        2 .           
; 0      100h  1FFh  Timer0.  12    256us  511us (   - 384us)
; 1      200h  2FFh  Timer0.  12    512us  767us (   - 640us)
;        300h  3FFh  Timer0.  12    768us  1023us (   - 900us)
;  -   ( , ,   )    ,   100h  1FFh  Timer0.  12    256us  511us (   - 384us)
;        -  
;      - 
;       ( )     -  
; -        -   (        300h  3FFh  Timer0)

;  :
;   :
;  2 : INT0 ( INT1),    Timer0.     Timer0 -   ( Timer0,      ).          
;  Timer0     (TL0 = 0, TH0 = 0FCh),    8  ,    
;      -  Timer0,    INT0 (INT1),       

;   :
;       -    INT0 (INT1)
;  TL0  0.    255    TH0.         

;     .   -   .   -   

;   
;   TH0.  TH0! = 0FFh -  
;  -     -     
;         

;   
;   TH0.  TH0 = 0FEh -  .0,  TH0 = 0FFh -  .1 (    :  0FEh   TH0. .1   , .0   .      .      ,    Timer0)
;       ( ),    .   0 -     8  

;     .  0,   1-   -  ,     ,  checksum (  ,     )

;    
; ĳ     ,     checksum,        ,   ,    
;         

;    ,  checksum
; ĳ     
;    .   0 -  .     checksum,  ,    .   
;    0,    (xrl)     checksum,     ,    
;         

;       
;  Timer0      (TH0 = 0FEh),  TL0   ,   ,     
;        Timer0:
; jb	TF0,	Receive_Error
; jnb	xy_mk_5v_pin,$-3
;     TH0.  TH0! = 0FFh,  
;   ,  Timer0     (TL0 = 0, TH0 = 0FDh)

;  :
; 1. 1   
; 2. 16-20   
; 3. 1 
; 4.   - LEN (LEN> = 2 && LEN <= BUFF_SIZE+1) DATA + CHECKSUM
; 5.   - DATA
; 6.   - CHECKSUM (LEN + XOR all DATA bytes)
;===============================================================================
XY_MK_5V_IRQ			equ	INT1
USE_PSW_BITS			equ	1													; 0 - max XY_MK_5V_BUFF_SIZE for AT89C1051 = 31, 1 - max XY_MK_5V_BUFF_SIZE for AT89C1051 = 48 (Stack = 6 bytes)
XY_MK_5V_BUFFSIZE		equ	48

if	USE_PSW_BITS = 1
xy_mk_5v_preamb_ok		bit PSW.1
xy_mk_5v_receive_compl	bit F0		; PSW.5
endif

if	XY_MK_5V_IRQ = INT0
xy_mk_5v_pin			bit	P3.2
elseif	XY_MK_5V_IRQ = INT1
xy_mk_5v_pin			bit	P3.3
else
ERROR
endif

TH0_PREAMB				equ	0FFh-3	; 0FCh
TH0_DATA				equ	0FFh-2	; 0FDh
TH0_LOW_LVL				equ	0FFh-1	; 0FEh
XY_MK_5V_BITNUM			equ	8

_stop_xy_mk_5v	macro
				clr		TR0														; stop T0
			if	XY_MK_5V_IRQ = INT0
				clr		EX0														; disable XY_MK_5V_IRQ
			elseif	XY_MK_5V_IRQ = INT1
				clr		EX1														; disable XY_MK_5V_IRQ
			else
				ERROR
			endif
				endm
